>From 2ebd57ce6314eac73eb954a08bcfdfbcf51a2cce Mon Sep 17 00:00:00 2001
From: Christina Fu <cfu@redhat.com>
Date: Wed, 8 Jul 2015 17:45:59 -0700
Subject: [PATCH 83/84] ecc Console - 1. clean up the tabs in the JSSConnection
 constructor

---
 .../admin/certsrv/connection/JSSConnection.java    | 86 +++++++++++-----------
 1 file changed, 43 insertions(+), 43 deletions(-)

diff --git a/base/console/src/com/netscape/admin/certsrv/connection/JSSConnection.java b/base/console/src/com/netscape/admin/certsrv/connection/JSSConnection.java
index a686a5af1edbdbd8984182c7149dadd1b8dce912..43d1c234b39df8e4c133cb6b6368e3f1a9c0d9f9 100644
--- a/base/console/src/com/netscape/admin/certsrv/connection/JSSConnection.java
+++ b/base/console/src/com/netscape/admin/certsrv/connection/JSSConnection.java
@@ -55,24 +55,24 @@ public class JSSConnection implements IConnection, SSLCertificateApprovalCallbac
      * variables
      *==========================================================*/
 
-	/* static variables */
-	static CryptoManager cryptoManager;
-	static CertificateFactory cf;
-	static SelectCertDialog selectCertDialog = null;
-        static PromptForTrustDialog promptForTrustDialog = null;
+    /* static variables */
+    static CryptoManager cryptoManager;
+    static CertificateFactory cf;
+    static SelectCertDialog selectCertDialog = null;
+    static PromptForTrustDialog promptForTrustDialog = null;
 
-	/* private valiable */
-	private InputStream httpIn;
-	private OutputStream httpOut;
-	private byte[] body;
-	private int bodyLen;
-	private String header;
-	private int available;
-	private int totalRead;
-	private boolean endOfHeader = false;
+    /* private valiable */
+    private InputStream httpIn;
+    private OutputStream httpOut;
+    private byte[] body;
+    private int bodyLen;
+    private String header;
+    private int available;
+    private int totalRead;
+    private boolean endOfHeader = false;
 
-	private static int HTTP_OK_RESPONSE = 200;
-	private static final String PANELNAME = "SSLCLIENT";
+    private static int HTTP_OK_RESPONSE = 200;
+    private static final String PANELNAME = "SSLCLIENT";
     private boolean abort = false;;
     private boolean mClientAuth = false;
     private boolean mCertAccepted = true;
@@ -81,46 +81,46 @@ public class JSSConnection implements IConnection, SSLCertificateApprovalCallbac
     private boolean mTokenPasswordInit = true;
     private boolean mTokenPasswdSame = true;
 
-	protected SSLSocket s = null;
+    protected SSLSocket s = null;
 
-	/*==========================================================
-	* constructors
-	*==========================================================*/
-	public JSSConnection(String host, int port)
-	    throws IOException, UnknownHostException {
+    /*==========================================================
+    * constructors
+    *==========================================================*/
+    public JSSConnection(String host, int port)
+        throws IOException, UnknownHostException {
 
-		UtilConsoleGlobals.initJSS();
-		cf = UtilConsoleGlobals.getX509CertificateFactory();
+        UtilConsoleGlobals.initJSS();
+        cf = UtilConsoleGlobals.getX509CertificateFactory();
         try {
             cryptoManager = CryptoManager.getInstance();
         } catch (Exception e) {
         }
 
-                org.mozilla.jss.ssl.SSLSocket.SSLVersionRange stream_range =
-                    new org.mozilla.jss.ssl.SSLSocket.SSLVersionRange(
-                        org.mozilla.jss.ssl.SSLSocket.SSLVersionRange.tls1_0,
-                        org.mozilla.jss.ssl.SSLSocket.SSLVersionRange.tls1_2);
+        org.mozilla.jss.ssl.SSLSocket.SSLVersionRange stream_range =
+            new org.mozilla.jss.ssl.SSLSocket.SSLVersionRange(
+                org.mozilla.jss.ssl.SSLSocket.SSLVersionRange.tls1_0,
+                org.mozilla.jss.ssl.SSLSocket.SSLVersionRange.tls1_2);
 
-                SSLSocket.setSSLVersionRangeDefault(
-                    org.mozilla.jss.ssl.SSLSocket.SSLProtocolVariant.STREAM,
-                    stream_range);
+        SSLSocket.setSSLVersionRangeDefault(
+            org.mozilla.jss.ssl.SSLSocket.SSLProtocolVariant.STREAM,
+            stream_range);
 
-                org.mozilla.jss.ssl.SSLSocket.SSLVersionRange datagram_range =
-                    new org.mozilla.jss.ssl.SSLSocket.SSLVersionRange(
-                        org.mozilla.jss.ssl.SSLSocket.SSLVersionRange.tls1_1,
-                        org.mozilla.jss.ssl.SSLSocket.SSLVersionRange.tls1_2);
+        org.mozilla.jss.ssl.SSLSocket.SSLVersionRange datagram_range =
+            new org.mozilla.jss.ssl.SSLSocket.SSLVersionRange(
+                org.mozilla.jss.ssl.SSLSocket.SSLVersionRange.tls1_1,
+                org.mozilla.jss.ssl.SSLSocket.SSLVersionRange.tls1_2);
 
-                SSLSocket.setSSLVersionRangeDefault(
-                    org.mozilla.jss.ssl.SSLSocket.SSLProtocolVariant.DATA_GRAM,
-                    datagram_range);
-		s = new SSLSocket(host, port, null, 0, this, this);
+        SSLSocket.setSSLVersionRangeDefault(
+            org.mozilla.jss.ssl.SSLSocket.SSLProtocolVariant.DATA_GRAM,
+            datagram_range);
+        s = new SSLSocket(host, port, null, 0, this, this);
 
-		// Initialze Http Input and Output Streams
-		httpIn = s.getInputStream();
-		httpOut = s.getOutputStream();
+        // Initialze Http Input and Output Streams
+        httpIn = s.getInputStream();
+        httpOut = s.getOutputStream();
         cryptoManager.setPasswordCallback(new pwcb());
         Debug.println("JSSConnection Debug: end of JSSConnection constructor");
-	}
+    }
 
     public boolean approve(org.mozilla.jss.crypto.X509Certificate serverCert,
        ValidityStatus status)
-- 
1.8.4.2